package com.elab.mq.config;


import com.aliyun.openservices.ons.api.*;
import com.aliyun.openservices.ons.api.bean.ProducerBean;
import com.elab.core.utils.RandomUtils;
import org.junit.Test;

import java.io.IOException;
import java.util.Properties;

public class RocketMQConfigurationTest {
    String topic = "T_consumer2";

    @Test
    public void mqProperties() {
        Properties properties = getProperties();
        ProducerBean producerBean = new ProducerBean();
        producerBean.setProperties(properties);
//        producerBean.setCallbackExecutor(new AbstractExecutorService() {
//            @Override
//            public void shutdown() {
//                System.out.println("-->shutdown");
//            }
//
//            @Override
//            public List<Runnable> shutdownNow() {
//                return null;
//            }
//
//            @Override
//            public boolean isShutdown() {
//                return false;
//            }
//
//            @Override
//            public boolean isTerminated() {
//                return false;
//            }
//
//            @Override
//            public boolean awaitTermination(long timeout, TimeUnit unit) throws InterruptedException {
//                return false;
//            }
//
//            @Override
//            public void execute(Runnable command) {
//                System.out.println("execute ... ");
//            }
//        });
        String text = "大家好 ... ";
        producerBean.start();
        for (int i = 0; i < 10; i++) {
            String key = RandomUtils.randomString(10);
            Message message = new Message("T-consumer1", "*", key, text.getBytes());
            SendResult send = producerBean.send(message);
            System.out.println("发送消息返回结果 : " + send.toString());
        }
    }

    /**
     * 对于全局顺序消息，建议创建实例个数 >=2。 同时运行多个实例的作用是为了防止工作实例意外退出时，业务中断。 当工作实例退出时，其他实例可以立即接手工作，不会导致业务中断，实际同时工作的只会有一个实例。
     *
     * @throws IOException
     */
    @Test
    public void consumer() throws IOException {
        Properties properties = getProperties();
        properties.put(PropertyKeyConst.GROUP_ID, "GID-producer1");
        Consumer consumer = ONSFactory.createConsumer(properties);
        MessageListener messageListener = new MessageListener() {
            @Override
            public Action consume(Message message, ConsumeContext consumeContext) {
                System.out.println("消费到的消息 : " + message.toString());
                return Action.CommitMessage;
            }
        };

        consumer.subscribe(topic, "*", messageListener);
        consumer.subscribe("T-consumer1", "*", messageListener);

        consumer.start();
        System.out.println("Consumer Started");
        System.in.read();
    }

    public Properties getProperties() {
        Properties properties = new Properties();
        // AccessKey 阿里云身份验证，在阿里云服务器管理控制台创建
        properties.put(PropertyKeyConst.AccessKey, "LTAImNZed054h0YV");
        // SecretKey 阿里云身份验证，在阿里云服务器管理控制台创建
        properties.put(PropertyKeyConst.SecretKey, "8hmhlhiQ2ikmVeLKujwMNWsktFpSzm");
        // 设置 TCP 接入域名，进入控制台的实例管理页面的“获取接入点信息”区域查看
        properties.put(PropertyKeyConst.NAMESRV_ADDR, "http://MQ_INST_1819241776271348_Bak3xjk0.mq-internet-access.mq-internet.aliyuncs.com:80");
        properties.put(PropertyKeyConst.GROUP_ID, "GID-producer1");
        //设置发送超时时间，单位毫秒
        properties.setProperty(PropertyKeyConst.SendMsgTimeoutMillis, "5000");

        properties.put(PropertyKeyConst.OnsChannel, "ALIYUN");
        // 顺序消息消费者失败进行重试前的等待时间(单位毫秒)
        properties.put(PropertyKeyConst.SuspendTimeMillis, "100");
        // 消费失败的重试次数
        properties.put(PropertyKeyConst.MaxReconsumeTimes, "20");
        return properties;
    }
}
